﻿using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Collections.Generic;
using System.IO;

namespace Understanding_Linq_1
{
    /// <summary>
    /// Summary description for Service3
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class WithFilterAndProjection : System.Web.Services.WebService
    {
        [WebMethod]
        public Employee1[] GetEmployee()
        {
            List<Employee> data = new List<Employee>();

            #region ...load data from file...
            using (StreamReader file = File.OpenText(base.Context.Request.MapPath("App_Data/Employees.csv")))
            {
                //skip header
                if (!file.EndOfStream) file.ReadLine();
                //read data
                while (!file.EndOfStream)
                {
                    string line = file.ReadLine();
                    line = line.Trim();

                    //convert to object
                    if (line.Length > 0)
                    {
                        string[] parts = line.Split(';');
                        data.Add(new Employee
                        {
                            Name = parts[0],
                            DateOfBirth = DateTime.Parse(parts[1]),
                            Sex = parts[2],
                            State = parts[3]
                        });
                    }
                }
            }
            #endregion

            #region ...apply filter...
            List<Employee> filtered = new List<Employee>();
            foreach (Employee person in data)
            {
                if (person.State =="R") filtered.Add(person);
            }
            #endregion

            //create projection
            List<Employee1> projected = new List<Employee1>();
            foreach (Employee employee in filtered)
            {
                projected.Add(new Employee1 
                { 
                    Name = employee.Name, 
                    Age = GetAge(employee), 
                    Sex = employee.Sex 
                });
            }

            return projected.ToArray();
        }

        private int GetAge(Employee person)
        {
            int result = (DateTime.Now.Year - person.DateOfBirth.Year);
            if ((DateTime.Now.Month < person.DateOfBirth.Month) || ((DateTime.Now.Month == person.DateOfBirth.Month) && (DateTime.Now.Day < person.DateOfBirth.Day))) result--;
            return result;
        }
    }
}
