﻿using System.Collections;
using System.ComponentModel;
using System.Web.Services;
using System.Collections.Generic;

using System.Linq;
using System;

namespace Understanding_Linq_2
{
    /// <summary>
    /// Summary description for Service1
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [ToolboxItem(false)]

    public class TheService : CsvService
    {
        [WebMethod]
        public Employee1[] GetEmployees()
        {
            using (CsvFileReader<Employee> data = LoadCsvData<Employee>("Employees.csv"))
            {
                Filter<Employee> filtered = new Filter<Employee>(data, 
                    delegate(Employee e)  {return e.State == "R";});

                Projector<Employee, Employee1> projected = new Projector<Employee,Employee1>(filtered,
                    delegate(Employee e) 
                    {
                        return new Employee1
                        {
                            Name = e.Name, 
                            Age = e.DateOfBirth.GetAge(), 
                            Sex=e.Sex
                        };
                    });

                return new List<Employee1>(projected).ToArray();
            }
        }

        [WebMethod]
        public Employee1[] GetEmployees2()
        {
            using (CsvFileReader<Employee> data = LoadCsvData<Employee>("Employees.csv"))
            {
                IEnumerable<Employee1> result = 
                    data.Where( e => e.State == "R")
                        .Select(e => new Employee1{Name = e.Name, Age = e.DateOfBirth.GetAge(), Sex=e.Sex});

                return new List<Employee1>(result).ToArray();
            }
        }

        [WebMethod]
        public Employee1[] GetEmployees3()
        {
            using (CsvFileReader<Employee> data = LoadCsvData<Employee>("Employees.csv"))
            {
                IEnumerable<Employee1> result = 
                    from employee in data
                    where employee.State == "R"
                    select new Employee1 { Name = employee.Name, Age = employee.DateOfBirth.GetAge(), Sex = employee.Sex };

                return new List<Employee1>(result).ToArray();
            }
        }
    }
}
