﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Linq.Expressions;
using System.Collections.Generic;

namespace Understanding_Linq_3a.Expressions
{
    public class CollectColumnAccess : ExpressionVisitor
    {
        public CollectColumnAccess(Expression expr)
        {
            ColumnsAccessed = new List<int>();
            Visit(expr);
        }

        public List<int> ColumnsAccessed { get; private set; }

        protected override Expression VisitMemberAccess(MemberExpression m)
        {
            if (m.Expression.NodeType == ExpressionType.Parameter)
            {
                CsvColumnAttribute[] info = (CsvColumnAttribute[])m.Member.GetCustomAttributes(typeof(CsvColumnAttribute), true);
                if ((info != null) && (info.Length > 0)) ColumnsAccessed.Add(info[0].ColumnIndex); 
            }
            
            return base.VisitMemberAccess(m);
        }
    }
}
